Subject: bug#70633: guix pull: package: extraneous field initializers (homempage)

From: "Artyom V. Poptsov" <[email-masked]>
Date: Sun, 28 Apr 2024 22:07:07 +0300

Hello,

today at 21:30 UTC+3 I tried to perform "guix pull" and got the
following error:

--8<---------------cut here---------------start------------->8---
$ guix pull
Updating channel 'guix' from Git repository at 'https://git.savannah.gnu.org/git/guix.git'...
Building from this channel:
  guix      https://git.savannah.gnu.org/git/guix.git	9f183c3
Computing Guix derivation for 'x86_64-linux'... \ice-9/psyntax.scm:2824:12: In procedure syntax-violation:
Syntax error:
unknown location: package: extraneous field initializers (homempage) in form (package (name "rust-paw-attributes") (version "1.0.2") (source (origin (method url-fetch) (uri (crate-uri "paw-attributes" version)) (file-name (string-append name "-" version ".tar.gz")) (sha256 (base32 "0fda1v7y5pfmg8d2v7m0pyvif6c44qjz914jjn718pdyclrmhd8g")))) (build-system cargo-build-system) (arguments (quasiquote (#:cargo-inputs (("rust-proc-macro2" (unquote rust-proc-macro2-1)) ("rust-quote" (unquote rust-quote-1)) ("rust-syn" (unquote rust-syn-1)))))) (homempage "https://github.com/rust-cli/paw") (synopsis "Proc Macro attributes for the Paw crate") (description "This package provides Proc Macro attributes for the Paw\ncrate.") (license (list license:expat license:asl2.0)))
guix pull: error: You found a bug: the program '/gnu/store/33hkpascp2rlkyays2d9lya8mj6mg4wn-compute-guix-derivation'
failed to compute the derivation for Guix (version: "9f183c3627a006e8fd3bb9708448bc05a6204e6d"; system: "x86_64-linux";
host version: "8d29f416a9378d30f63c2a95f1bd1a420d9ccab4"; pull-version: 1).
Please report the COMPLETE output above by email to <[email-masked]>.
--8<---------------cut here---------------end--------------->8---

As my colleagues from Russian Guix community pointed out, "home-page"
and "homempage" differ only in one symbol: "-" and "m".  "-" is 45 in
ACII and "m" is 109.

I checked "gnu/packages/crates-io.scm" from the Guix distribution and
found no occurrences of "homempage":

--8<---------------cut here---------------start------------->8---
$ grep -R "homempage" gnu/packages/*
--8<---------------cut here---------------end--------------->8---

Binary representation suspiciously differs only in 1 bit:
--8<---------------cut here---------------start------------->8---
'-'  45    0010 1101
'm'  109   0110 1101
            ^
--8<---------------cut here---------------end--------------->8---

I checked my Emacs setup and currently there's no "M-x M-c M-butterfly"
running. [1]

- avp

References:
1. https://xkcd.com/378/

-- 
Artyom "avp" Poptsov <[email-masked]>
Home page: https://memory-heap.org/~avp/
CADR Hackerspace co-founder: https://cadrspace.ru/
GPG: D0C2 EAC1 3310 822D 98DE  B57C E9C5 A2D9 0898 A02F